name: Build libsm64

on: [ push, pull_request ]

jobs:
  Build:
    name: Build libsm64 for ${{ matrix.identifier }}
    strategy:
      fail-fast: false
      matrix:
        include:
          - identifier: linux
            os: ubuntu-latest
          - identifier: windows
            os: ubuntu-latest
          - identifier: web
            os: ubuntu-latest
    runs-on: ${{ matrix.os }}
    steps:
      - name: Checkout project
        uses: actions/checkout@v4

      - name: Set up Python
        uses: actions/setup-python@v5
        with:
          python-version: '3.10'

      - name: (Windows) Install MinGW
        if: ${{ startsWith(matrix.identifier, 'windows') }}
        run: |
          sudo apt-get update -y -qq
          sudo apt-get install -y mingw-w64
          sudo update-alternatives --set x86_64-w64-mingw32-gcc /usr/bin/x86_64-w64-mingw32-gcc-posix
          sudo update-alternatives --set x86_64-w64-mingw32-g++ /usr/bin/x86_64-w64-mingw32-g++-posix

      - name: (Windows) Prepare cross compilation
        if: ${{ startsWith(matrix.identifier, 'windows') }}
        shell: sh
        run: |
          echo "OS=Windows_NT" >> $GITHUB_ENV

      - name: (Linux) Install dependencies
        if: ${{ startsWith(matrix.identifier, 'linux') }}
        run: |
          sudo add-apt-repository -y "deb http://archive.ubuntu.com/ubuntu `lsb_release -sc` main universe restricted multiverse"
          sudo apt-get update -y -qq
          sudo apt-get install -y libsdl2-dev libglew-dev

      - name: (Web) Set up Emscripten
        if: ${{ startsWith(matrix.identifier, 'web') }}
        uses: mymindstorm/setup-emsdk@v14

      - name: Build shared library
        shell: bash
        run: |
          if [[ "${{ matrix.identifier }}" == "web" ]]; then
              emmake make lib -j $(nproc) CC=emcc
          elif [[ "${{ matrix.identifier }}" == "windows" ]]; then
              make lib -j $(nproc 2>/dev/null || sysctl -n hw.ncpu) \
                CC=x86_64-w64-mingw32-gcc \
                CXX=x86_64-w64-mingw32-g++
          else
              make lib -j $(nproc 2>/dev/null || sysctl -n hw.ncpu)
          fi

      - name: (Linux) Build test executable
        if: ${{ startsWith(matrix.identifier, 'linux') }}
        run: |
          make test -j`nproc`

      - name: Upload build
        uses: actions/upload-artifact@v3
        with:
          name: libsm64_${{ matrix.identifier }}
          path: |
            ./README.md
            ./dist
            ./run-test

  #Release:
  #  name: "Snapshot Release"
  #  runs-on: "ubuntu-latest"
  #  needs: Build

  #  steps:
  #    - name: Download artifacts
  #      uses: actions/download-artifact@v3

  #    - name: Create a Release
  #      uses: "marvinpinto/action-automatic-releases@latest"
  #      with:
  #        repo_token: "${{ secrets.GITHUB_TOKEN }}"
  #        automatic_release_tag: "latest"
  #        prerelease: true
  #        title: "Snapshot Build"
  #        files: |
  #         ./README.md
  #         ./dist